package controller

import (
	"encoding/json"
	"fmt"
	"strconv"
	"strings"
	"time"

	"be.ems/src/framework/i18n"
	"be.ems/src/framework/utils/ctx"
	"be.ems/src/framework/utils/file"
	"be.ems/src/framework/utils/parse"
	"be.ems/src/framework/vo/result"
	"be.ems/src/modules/monitor/model"
	"be.ems/src/modules/monitor/service"
	systemService "be.ems/src/modules/system/service"

	"github.com/gin-gonic/gin"
	"github.com/gin-gonic/gin/binding"
)

// 实例化控制层 SysJobLogController 结构体
var NewSysJob = &SysJobController{
	sysJobService:      service.NewSysJob,
	sysDictDataService: systemService.NewSysDictData,
}

// 调度任务信息
//
// PATH /monitor/job
type SysJobController struct {
	sysJobService      *service.SysJob            // 调度任务服务
	sysDictDataService *systemService.SysDictData // 字典数据服务
}

// 调度任务列表
//
// GET /list
func (s *SysJobController) List(c *gin.Context) {
	language := ctx.AcceptLanguage(c)
	querys := ctx.QueryMap(c)
	// 多语言值转key查询
	if v, ok := querys["jobName"]; ok && v != "" {
		querys["jobName"] = i18n.TFindKeyPrefix(language, "job", v.(string))
	}

	data := s.sysJobService.SelectJobPage(querys)
	rows := data["rows"].([]model.SysJob)

	// 闭包函数处理多语言
	converI18n := func(language string, arr *[]model.SysJob) {
		for i := range *arr {
			(*arr)[i].JobName = i18n.TKey(language, (*arr)[i].JobName)
			(*arr)[i].Remark = i18n.TKey(language, (*arr)[i].Remark)
		}
	}
	converI18n(language, &rows)

	c.JSON(200, result.Ok(data))
}

// 调度任务信息
//
// GET /:jobId
func (s *SysJobController) Info(c *gin.Context) {
	language := ctx.AcceptLanguage(c)
	jobId := c.Param("jobId")
	if jobId == "" {
		c.JSON(400, result.CodeMsg(400, i18n.TKey(language, "app.common.err400")))
		return
	}

	data := s.sysJobService.SelectJobById(jobId)
	if data.JobID == jobId {
		// 处理多语言
		data.JobName = i18n.TKey(language, data.JobName)
		data.Remark = i18n.TKey(language, data.Remark)
		c.JSON(200, result.OkData(data))
		return
	}
	c.JSON(200, result.Err(nil))
}

// 调度任务新增
//
// POST /
func (s *SysJobController) Add(c *gin.Context) {
	language := ctx.AcceptLanguage(c)
	var body model.SysJob
	err := c.ShouldBindBodyWith(&body, binding.JSON)
	if err != nil || body.JobID != "" {
		c.JSON(400, result.CodeMsg(400, i18n.TKey(language, "app.common.err400")))
		return
	}

	// 检查cron表达式格式
	if parse.CronExpression(body.CronExpression) == 0 {
		// 调度任务新增【%s】失败，Cron表达式不正确
		msg := i18n.TTemplate(language, "job.errCronExpression", map[string]any{"name": body.JobName})
		c.JSON(200, result.ErrMsg(msg))
		return
	}

	// 检查任务调用传入参数是否json格式
	if body.TargetParams != "" {
		// 调度任务新增【%s】失败，任务传入参数json字符串不正确
		msg := i18n.TTemplate(language, "job.errTargetParams", map[string]any{"name": body.JobName})
		if len(body.TargetParams) < 7 {
			c.JSON(200, result.ErrMsg(msg))
			return
		}
		if !json.Valid([]byte(body.TargetParams)) {
			c.JSON(200, result.ErrMsg(msg))
			return
		}
	}

	// 检查属性值唯一
	uniqueJob := s.sysJobService.CheckUniqueJobName(body.JobName, body.JobGroup, "")
	if !uniqueJob {
		// 调度任务新增【%s】失败，同任务组内有相同任务名称
		msg := i18n.TTemplate(language, "job.errJobExists", map[string]any{"name": body.JobName})
		c.JSON(200, result.ErrMsg(msg))
		return
	}

	body.CreateBy = ctx.LoginUserToUserName(c)
	insertId := s.sysJobService.InsertJob(body)
	if insertId != "" {
		c.JSON(200, result.Ok(nil))
		return
	}
	c.JSON(200, result.Err(nil))
}

// 调度任务修改
//
// PUT /
func (s *SysJobController) Edit(c *gin.Context) {
	language := ctx.AcceptLanguage(c)
	var body model.SysJob
	err := c.ShouldBindBodyWith(&body, binding.JSON)
	if err != nil || body.JobID == "" {
		c.JSON(400, result.CodeMsg(400, i18n.TKey(language, "app.common.err400")))
		return
	}

	// 检查cron表达式格式
	if parse.CronExpression(body.CronExpression) == 0 {
		// 调度任务修改【%s】失败，Cron表达式不正确
		msg := i18n.TTemplate(language, "job.errCronExpression", map[string]any{"name": body.JobName})
		c.JSON(200, result.ErrMsg(msg))
		return
	}

	// 检查任务调用传入参数是否json格式
	if body.TargetParams != "" {
		// 调度任务修改【%s】失败，任务传入参数json字符串不正确
		msg := i18n.TTemplate(language, "job.errTargetParams", map[string]any{"name": body.JobName})
		if len(body.TargetParams) < 7 {
			c.JSON(200, result.ErrMsg(msg))
			return
		}
		if !json.Valid([]byte(body.TargetParams)) {
			c.JSON(200, result.ErrMsg(msg))
			return
		}
	}

	// 检查是否存在
	job := s.sysJobService.SelectJobById(body.JobID)
	if job.JobID != body.JobID {
		// 没有可访问调度任务数据！
		c.JSON(200, result.ErrMsg(i18n.TKey(language, "job.noData")))
		return
	}

	// 检查属性值唯一
	uniqueJob := s.sysJobService.CheckUniqueJobName(body.JobName, body.JobGroup, body.JobID)
	if !uniqueJob {
		// 调度任务修改【%s】失败，同任务组内有相同任务名称
		msg := i18n.TTemplate(language, "job.errJobExists", map[string]any{"name": body.JobName})
		c.JSON(200, result.ErrMsg(msg))
		return
	}

	// 多语言非原始值
	i18nValue := i18n.TKey(language, job.JobName)
	if i18nValue != job.JobName {
		i18n.UpdateKeyValue(language, job.JobName, body.JobName)
		body.JobName = job.JobName
	}
	// 多语言非原始值
	i18nValue2 := i18n.TKey(language, job.Remark)
	if i18nValue2 != job.Remark {
		i18n.UpdateKeyValue(language, job.Remark, body.Remark)
		body.Remark = job.Remark
	}

	body.UpdateBy = ctx.LoginUserToUserName(c)
	rows := s.sysJobService.UpdateJob(body)
	if rows > 0 {
		c.JSON(200, result.Ok(nil))
		return
	}
	c.JSON(200, result.Err(nil))
}

// 调度任务删除
//
// DELETE /:jobIds
func (s *SysJobController) Remove(c *gin.Context) {
	language := ctx.AcceptLanguage(c)
	jobIds := c.Param("jobIds")
	if jobIds == "" {
		c.JSON(400, result.CodeMsg(400, i18n.TKey(language, "app.common.err400")))
		return
	}
	// 处理字符转id数组后去重
	ids := strings.Split(jobIds, ",")
	uniqueIDs := parse.RemoveDuplicates(ids)
	if len(uniqueIDs) <= 0 {
		c.JSON(200, result.Err(nil))
		return
	}
	rows, err := s.sysJobService.DeleteJobByIds(uniqueIDs)
	if err != nil {
		c.JSON(200, result.ErrMsg(err.Error()))
		return
	}
	msg := i18n.TTemplate(language, "app.common.deleteSuccess", map[string]any{"num": rows})
	c.JSON(200, result.OkMsg(msg))
}

// 调度任务修改状态
//
// PUT /changeStatus
func (s *SysJobController) Status(c *gin.Context) {
	language := ctx.AcceptLanguage(c)
	var body struct {
		// 任务ID
		JobId string `json:"jobId" binding:"required"`
		// 状态
		Status string `json:"status" binding:"required"`
	}
	err := c.ShouldBindBodyWith(&body, binding.JSON)
	if err != nil {
		c.JSON(400, result.CodeMsg(400, i18n.TKey(language, "app.common.err400")))
		return
	}

	// 检查是否存在
	job := s.sysJobService.SelectJobById(body.JobId)
	if job.JobID != body.JobId {
		// 没有可访问调度任务数据！
		c.JSON(200, result.ErrMsg(i18n.TKey(language, "job.noData")))
		return
	}

	// 与旧值相等不变更
	if job.Status == body.Status {
		// 变更状态与旧值相等！
		c.JSON(200, result.ErrMsg(i18n.TKey(language, "job.statusEq")))
		return
	}

	// 更新状态
	job.Status = body.Status
	job.UpdateBy = ctx.LoginUserToUserName(c)
	rows := s.sysJobService.UpdateJob(job)
	if rows > 0 {
		c.JSON(200, result.Ok(nil))
		return
	}
	c.JSON(200, result.Err(nil))
}

// 调度任务立即执行一次
//
// PUT /run/:jobId
func (s *SysJobController) Run(c *gin.Context) {
	language := ctx.AcceptLanguage(c)
	jobId := c.Param("jobId")
	if jobId == "" {
		c.JSON(400, result.CodeMsg(400, i18n.TKey(language, "app.common.err400")))
		return
	}

	// 检查是否存在
	job := s.sysJobService.SelectJobById(jobId)
	if job.JobID != jobId {
		// 没有可访问调度任务数据！
		c.JSON(200, result.ErrMsg(i18n.TKey(language, "job.noData")))
		return
	}

	ok := s.sysJobService.RunQueueJob(job)
	if ok {
		c.JSON(200, result.Ok(nil))
		return
	}
	c.JSON(200, result.Err(nil))
}

// 调度任务重置刷新队列
//
// PUT /resetQueueJob
func (s *SysJobController) ResetQueueJob(c *gin.Context) {
	s.sysJobService.ResetQueueJob()
	c.JSON(200, result.Ok(nil))
}

// 导出调度任务信息
//
// POST /export
func (s *SysJobController) Export(c *gin.Context) {
	language := ctx.AcceptLanguage(c)
	// 查询结果，根据查询条件结果，单页最大值限制
	querys := ctx.BodyJSONMap(c)
	querys["pageNum"] = 1
	querys["pageSize"] = 10000
	data := s.sysJobService.SelectJobPage(querys)
	if parse.Number(data["total"]) == 0 {
		// 导出数据记录为空
		c.JSON(200, result.ErrMsg(i18n.TKey(language, "app.common.exportEmpty")))
		return
	}
	rows := data["rows"].([]model.SysJob)

	// rows := s.sysJobService.SelectJobList(model.SysJob{})
	if len(rows) <= 0 {
		// 导出数据记录为空
		c.JSON(200, result.ErrMsg(i18n.TKey(language, "app.common.exportEmpty")))
		return
	}

	// 闭包函数处理多语言
	converI18n := func(language string, arr *[]model.SysJob) {
		for i := range *arr {
			(*arr)[i].JobName = i18n.TKey(language, (*arr)[i].JobName)
			(*arr)[i].Remark = i18n.TKey(language, (*arr)[i].Remark)
		}
	}
	converI18n(language, &rows)

	// 导出文件名称
	fileName := fmt.Sprintf("job_export_%d_%d.xlsx", len(rows), time.Now().UnixMilli())
	// 第一行表头标题
	headerCells := map[string]string{
		"A1": i18n.TKey(language, "job.export.jobID"),
		"B1": i18n.TKey(language, "job.export.jobName"),
		"C1": i18n.TKey(language, "job.export.jobGroupName"),
		"D1": i18n.TKey(language, "job.export.invokeTarget"),
		"E1": i18n.TKey(language, "job.export.cronExpression"),
		"F1": i18n.TKey(language, "job.export.status"),
		"G1": i18n.TKey(language, "job.export.remark"),
		// "E1": i18n.TKey(language, "job.export.targetParams"),
	}
	// 读取任务组名字典数据
	dictSysJobGroup := s.sysDictDataService.SelectDictDataByType("sys_job_group")
	// 从第二行开始的数据
	dataCells := make([]map[string]any, 0)
	for i, row := range rows {
		idx := strconv.Itoa(i + 2)
		// 任务组名
		sysJobGroup := ""
		for _, v := range dictSysJobGroup {
			if row.JobGroup == v.DictValue {
				sysJobGroup = i18n.TKey(language, v.DictLabel)
				break
			}
		}

		// 状态
		statusValue := i18n.TKey(language, "dictData.fail")
		if row.Status == "1" {
			statusValue = i18n.TKey(language, "dictData.success")
		}
		dataCells = append(dataCells, map[string]any{
			"A" + idx: row.JobID,
			"B" + idx: row.JobName,
			"C" + idx: sysJobGroup,
			"D" + idx: row.InvokeTarget,
			"E" + idx: row.CronExpression,
			"F" + idx: statusValue,
			"G" + idx: row.Remark,
			// "E" + idx: row.TargetParams,
		})
	}

	// 导出数据表格
	saveFilePath, err := file.WriteSheet(headerCells, dataCells, fileName, "")
	if err != nil {
		c.JSON(200, result.ErrMsg(err.Error()))
		return
	}

	c.FileAttachment(saveFilePath, fileName)
}
